import type { PriorityName } from './constants';
export type MergerResult<A, B> = A extends B ? B extends A ? (A extends {} ? B : A) : (A & B) : (A & B);
export type Merger = <A extends Record<string, any>, B extends Record<string, any>>(target: A, ...sources: B[]) => MergerResult<A, B>;
export type Options = {
    array: boolean;
    arrayDistinct: boolean;
    strategy?: (target: Record<string, any>, key: string, value: unknown) => Record<string, any> | undefined;
    priority: `${PriorityName}`;
};
export type OptionsInput = Partial<Options>;
